module HandHand where

import Common

allbuR_C_S f (C ds) = C `liftM` mapM (allbuR_D_S f) ds
allbuR_D_S f (D n m us) =
  D n `liftM` allbuR_E_S f m `ap` mapM (allbuR_U_S f) us
allbuR_E_S f (E p s) = E p `liftM` f s
allbuR_U_S f (PU e) = PU `liftM` allbuR_E_S f e
allbuR_U_S f (DU d) = DU `liftM` allbuR_D_S f d

data SATs m = SATs {_sat_C :: Company -> m Company,
                    _sat_D :: Dept -> m Dept,
                    _sat_U :: Unit -> m Unit,
                    _sat_E :: Employee -> m Employee}

allbuR_S_sat f = SATs wC wD wU wE where
  wC (C ds) = C `liftM` mapM wD ds
  wD (D n m us) =
    D n `liftM` wE m `ap` mapM wU us
  wE (E p s) = E p `liftM` f s
  wU (PU e) = PU `liftM` wE e
  wU (DU d) = DU `liftM` wD d
{-# INLINE allbuR_S_sat #-}
